export default {
  content: ['./index.html', './src/**/*.{js,ts,jsx,tsx}'],
  darkMode: 'class',
  theme: {
    extend: {
      colors: {
        primary: {
          50: '#f0f6ff',
          100: '#e0edff',
          200: '#c0daff',
          300: '#92bfff',
          400: '#5c9aff',
          500: '#3374ff',
          600: '#1e55ff',
          700: '#1342f1',
          800: '#1635d1',
          900: '#1733a5',
          950: '#101f5e',
        },
        secondary: {
          50: '#f5f3ff',
          100: '#ede8ff',
          200: '#ded5ff',
          300: '#c6b4ff',
          400: '#aa88ff',
          500: '#9055ff',
          600: '#7c38f2',
          700: '#6a24db',
          800: '#5820b5',
          900: '#481c91',
          950: '#2c0e67',
        },
        success: {
          50: '#edfdf4',
          100: '#d3fadf',
          200: '#aaf0c4',
          300: '#73e2a3',
          400: '#3acd7e',
          500: '#16b364',
          600: '#098f4e',
          700: '#087241',
          800: '#095c36',
          900: '#084c2e',
          950: '#022b1a',
        },
        warning: {
          50: '#fffce8',
          100: '#fff9c2',
          200: '#fff087',
          300: '#ffdf41',
          400: '#ffcb0a',
          500: '#edb100',
          600: '#cc8a00',
          700: '#a26304',
          800: '#874e0c',
          900: '#734010',
          950: '#422105',
        },
        error: {
          50: '#fff1f2',
          100: '#ffe4e5',
          200: '#ffccce',
          300: '#ffa2a6',
          400: '#fd6d72',
          500: '#f53e44',
          600: '#e12028',
          700: '#bd161e',
          800: '#9d151c',
          900: '#82151c',
          950: '#470709',
        },
        gray: {
          50: '#f9fafb',
          100: '#f3f4f6',
          200: '#e5e7eb',
          300: '#d1d5db',
          400: '#9ca3af',
          500: '#6b7280',
          600: '#4b5563',
          700: '#374151',
          800: '#1f2937',
          900: '#111827',
          950: '#030712',
        },
      },
      animation: {
        'fade-in': 'fadeIn 0.3s ease-in-out',
        'slide-up': 'slideUp 0.3s ease-out',
        'slide-down': 'slideDown 0.3s ease-out',
        'scale-up': 'scaleUp 0.2s ease-out',
      },
      keyframes: {
        fadeIn: {
          '0%': { opacity: 0 },
          '100%': { opacity: 1 },
        },
        slideUp: {
          '0%': { transform: 'translateY(10px)', opacity: 0 },
          '100%': { transform: 'translateY(0)', opacity: 1 },
        },
        slideDown: {
          '0%': { transform: 'translateY(-10px)', opacity: 0 },
          '100%': { transform: 'translateY(0)', opacity: 1 },
        },
        scaleUp: {
          '0%': { transform: 'scale(0.95)', opacity: 0 },
          '100%': { transform: 'scale(1)', opacity: 1 },
        },
      },
    },
  },
  plugins: [],
};